"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _pluginSyntaxTypescript = _interopRequireDefault(require("@babel/plugin-syntax-typescript"));

var _path = _interopRequireDefault(require("path"));

var types = _interopRequireWildcard(require("@babel/types"));

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// ///// plugin
var _default = babel => {
  return {
    inherits: _pluginSyntaxTypescript.default,
    name: 'babel-plugin-s2s-action-creator-ts',
    visitor: {
      Program: {
        exit(programPath, state) {
          const {
            file
          } = state;
          const filename = file.opts.filename;

          const basename = _path.default.basename(filename, _path.default.extname(filename));

          const existInterface = new Map();
          const imports = [];
          programPath.traverse({
            ImportDeclaration(path) {
              imports.push(path.node);
            },

            TSInterfaceDeclaration(path) {
              existInterface.set(path.node.id.name, path.node.body.body);
            }

          });
          const functionsAst = Array.from(existInterface).map(([key, fileds]) => {
            let ignoreTypeFileds = fileds.filter(f => f.key.name !== 'type');
            let fnc = types.FunctionDeclaration( // export function FUGA
            types.Identifier(key.toLowerCase()), // function name
            ignoreTypeFileds.map(f => {
              // args
              let id = types.Identifier(f.key.name);
              id.typeAnnotation = f.typeAnnotation;
              return id;
            }), types.BlockStatement([// statements
            types.ReturnStatement(types.ObjectExpression([// fileds
            types.ObjectProperty(types.Identifier('type'), types.MemberExpression(types.Identifier('Actions'), types.Identifier(key))), ...ignoreTypeFileds.map(f => {
              let obj = types.ObjectProperty(f.key, types.Identifier(f.key.name));
              obj.shorthand = true;
              return obj;
            })]))]));
            fnc.returnType = types.TSTypeAnnotation(types.TSTypeReference(types.Identifier(key)));
            return types.ExportNamedDeclaration(fnc, []);
          });
          const importSpecs = [['Actions'], ...Array.from(existInterface)].map(([key, fileds]) => {
            const id = types.Identifier(key);
            return types.ImportSpecifier(id, id);
          });
          const actionImports = types.ImportDeclaration(importSpecs, types.StringLiteral(`./${basename}`)); // generate node tree

          programPath.node.body = [...imports, actionImports, ...functionsAst];
          programPath.node.body[0].leadingComments = [{
            type: 'CommentBlock',
            value: '**** Do not edit this file ****'
          }];
        }

      }
    }
  };
};

exports.default = _default;